/*
 * ExtractLCFRS.h
 *
 *  Created on: 09.01.2013
 *      Author: kaeshammer
 */

#pragma once
#ifndef EXTRACT_LCFRS_EXTRACT_LCFRS_H_
#define EXTRACT_LCFRS_EXTRACT_LCFRS_H_

#include <string>
#include <vector>

#include "OutputFileStream.h"


namespace LCFRS {

struct Options;

class ExtractLCFRS {
public:
  ExtractLCFRS(): m_name("validate-alignment") {}
  int Main(int argc, char *argv[]);
  const std::string &GetName() const { return m_name; }

private:
  void OpenOutputFileOrDie(const std::string &filename,
                                        Moses::OutputFileStream &stream);
  void OpenOutputFileOrDie(const std::string &filename,
                                        std::ofstream &stream);
  void Error(const std::string &msg) const;
  void PrintOutputHeader(Moses::OutputFileStream& stream, int maxNumBlocksS, int maxNumBlocksT, int maxS, int maxT, bool nf);
  void PrintOutputFooter(Moses::OutputFileStream& stream, int sent, int sentParsed);
  void ProcessOptions(int, char *[], Options &) const;
  std::vector<std::string> ReadTokens(const std::string &s);
  std::string m_name;
};

}

#endif /* EXTRACT_LCFRS_EXTRACT_LCFRS_H_ */
